## mongodb 3.2.9

=== SConstruct ===
# -*- mode: python; -*-
import copy
import datetime
import errno
import json
import os
import re
import shlex
import shutil
import stat
import sys
import textwrap
import uuid
from buildscripts import utils
from buildscripts import moduleconfig

from mongo_scons_utils import (
    default_buildinfo_environment_data,
    default_variant_dir_generator,
    get_toolchain_ver,
)

import libdeps

EnsureSConsVersion( 2, 3, 0 )

def versiontuple(v):
    return tuple(map(int, (v.split("."))))

# --- OS identification ---
#
# This needs to precede the options section so that we can only offer some options on certain
# operating systems.

# This function gets the running OS as identified by Python
# It should only be used to set up defaults for options/variables, because
# its value could potentially be overridden by setting TARGET_OS on the
# command-line. Treat this output as the value of HOST_OS
def get_running_os_name():
    running_os = os.sys.platform
    if running_os.startswith('linux'):
        running_os = 'linux'
    elif running_os.startswith('freebsd'):
        running_os = 'freebsd'
    elif running_os.startswith('openbsd'):
        running_os = 'openbsd'
    elif running_os == 'sunos5':
        running_os = 'solaris'
    elif running_os == 'win32':
        running_os = 'windows'
    elif running_os == 'darwin':
        running_os = 'osx'
    else:
        running_os = 'unknown'
    return running_os

def env_get_os_name_wrapper(self):
    return env['TARGET_OS']

def is_os_raw(target_os, os_list_to_check):
    okay = False
    posix_os_list = [ 'linux', 'openbsd', 'freebsd', 'osx', 'solaris' ]

    for p in os_list_to_check:
        if p == 'posix' and target_os in posix_os_list:
            okay = True
            break
        elif p == target_os:
            okay = True
            break
    return okay

# This function tests the running OS as identified by Python
# It should only be used to set up defaults for options/variables, because
# its value could potentially be overridden by setting TARGET_OS on the
# command-line. Treat this output as the value of HOST_OS
def is_running_os(*os_list):
    return is_os_raw(get_running_os_name(), os_list)

def env_os_is_wrapper(self, *os_list):
    return is_os_raw(self['TARGET_OS'], os_list)

def add_option(name, **kwargs):

    if 'dest' not in kwargs:
        kwargs['dest'] = name

    if 'metavar' not in kwargs and kwargs.get('type', None) == 'choice':
        kwargs['metavar'] = '[' + '|'.join(kwargs['choices']) + ']'

    AddOption('--' + name, **kwargs)

def get_option(name):
    return GetOption(name)

def has_option(name):
    optval = GetOption(name)
    # Options with nargs=0 are true when their value is the empty tuple. Otherwise,
    # if the value is falsish (empty string, None, etc.), coerce to False.
    return True if optval == () else bool(optval)

def use_system_version_of_library(name):
    return has_option('use-system-all') or has_option('use-system-' + name)

# Returns true if we have been configured to use a system version of any C++ library. If you
# add a new C++ library dependency that may be shimmed out to the system, add it to the below
# list.
def using_system_version_of_cxx_libraries():
    cxx_library_names = ["tcmalloc", "boost"]
    return True in [use_system_version_of_library(x) for x in cxx_library_names]

def make_variant_dir_generator():
    memoized_variant_dir = [False]
    def generate_variant_dir(target, source, env, for_signature):
        if not memoized_variant_dir[0]:
            memoized_variant_dir[0] = env.subst('$BUILD_ROOT/$VARIANT_DIR')
        return memoized_variant_dir[0]
    return generate_variant_dir

# Options TODOs:
#
# - We should either alphabetize the entire list of options, or split them into logical groups
#   with clear boundaries, and then alphabetize the groups. There is no way in SCons though to
#   inform it of options groups.
#
# - Many of these options are currently only either present or absent. This is not good for
#   scripting the build invocation because it means you need to interpolate in the presence of
#   the whole option. It is better to make all options take an optional on/off or true/false
#   using the nargs='const' mechanism.
#

add_option('prefix',
    default='$BUILD_ROOT/install',
    help='installation prefix',
)

add_option('nostrip',
    help='do not strip installed binaries',
    nargs=0,
)

add_option('build-dir',
    default='#build',
    help='build output directory',
)

add_option('release',
    help='release build',
    nargs=0,
)

add_option('lto',
    help='enable link time optimizations (experimental, except with MSVC)',
    nargs=0,
)

add_option('dynamic-windows',
    help='dynamically link on Windows',
    nargs=0,
)

add_option('endian',
    choices=['big', 'little', 'auto'],
    default='auto',
    help='endianness of target platform',
    nargs=1,
    type='choice',
)

add_option('disable-minimum-compiler-version-enforcement',
    help='allow use of unsupported older compilers (NEVER for production builds)',
    nargs=0,
)

add_option('ssl',
    help='Enable SSL',
    nargs=0
)

add_option('mmapv1',
    choices=['auto', 'on', 'off'],
    default='auto',
    help='Enable MMapV1',
    nargs='?',
    type='choice',
)

add_option('wiredtiger',
    choices=['on', 'off'],
    const='on',
    default='on',
    help='Enable wiredtiger',
    nargs='?',
    type='choice',
)

js_engine_choices = ['mozjs', 'none']
add_option('js-engine',
    choices=js_engine_choices,
    default=js_engine_choices[0],
    help='JavaScript scripting engine implementation',
    type='choice',
)

add_option('server-js',
    choices=['on', 'off'],
    const='on',
    default='on',
    help='Build mongod without JavaScript support',
    type='choice',
)

add_option('libc++',
    help='use libc++ (experimental, requires clang)',
    nargs=0,
)

add_option('use-glibcxx-debug',
    help='Enable the glibc++ debug implementations of the C++ standard libary',
    nargs=0,
)

add_option('noshell',
    help="don't build shell",
    nargs=0,
)

add_option('safeshell',
    help="don't let shell scripts run programs (still, don't run untrusted scripts)",
    nargs=0,
)

add_option('dbg',
    choices=['on', 'off'],
    const='on',
    default='off',
    help='Enable runtime debugging checks',
    nargs='?',
    type='choice',
)

add_option('spider-monkey-dbg',
    choices=['on', 'off'],
    const='on',
    default='off',
    help='Enable SpiderMonkey debug mode',
    nargs='?',
    type='choice',
)

add_option('opt',
    choices=['on', 'off'],
    const='on',
    help='Enable compile-time optimization',
    nargs='?',
    type='choice',
)

add_option('sanitize',
    help='enable selected sanitizers',
    metavar='san1,san2,...sanN',
)

add_option('llvm-symbolizer',
    default='llvm-symbolizer',
    help='name of (or path to) the LLVM symbolizer',
)

add_option('durableDefaultOn',
    help='have durable default to on',
    nargs=0,
)

add_option('allocator',
    choices=["auto", "system", "tcmalloc"],
    default="auto",
    help='allocator to use (use "auto" for best choice for current platform)',
    type='choice',
)

add_option('gdbserver',
    help='build in gdb server support',
    nargs=0,
)

add_option('gcov',
    help='compile with flags for gcov',
    nargs=0,
)

add_option('smokedbprefix',
    help='prefix to dbpath et al. for smoke tests',
)

add_option('smokeauth',
    help='run smoke tests with --auth',
    nargs=0,
)

add_option('use-sasl-client',
    help='Support SASL authentication in the client library',
    nargs=0,
)

add_option('use-system-tcmalloc',
    help='use system version of tcmalloc library',
    nargs=0,
)

add_option('use-system-pcre',
    help='use system version of pcre library',
    nargs=0,
)

add_option('use-system-wiredtiger',
    help='use system version of wiredtiger library',
    nargs=0,
)

boost_choices = ['1.56']
add_option('internal-boost',
    choices=boost_choices,
    default=boost_choices[0],
    help='Specify internal boost version to use',
    type='choice',
)

add_option('system-boost-lib-search-suffixes',
    help='Comma delimited sequence of boost library suffixes to search',
)

add_option('use-system-boost',
    help='use system version of boost libraries',
    nargs=0,
)

add_option('use-system-snappy',
    help='use system version of snappy library',
    nargs=0,
)

add_option('use-system-valgrind',
    help='use system version of valgrind library',
    nargs=0,
)

add_option('use-system-zlib',
    help='use system version of zlib library',
    nargs=0,
)

add_option('use-system-stemmer',
    help='use system version of stemmer',
    nargs=0)

add_option('use-system-yaml',
    help='use system version of yaml',
    nargs=0,
)

add_option('use-system-asio',
    help="use system version of ASIO",
    nargs=0,
)

add_option('use-system-intel_decimal128',
    help='use system version of intel decimal128',
    nargs=0,
)

add_option('use-system-all',
    help='use all system libraries',
    nargs=0,
)

add_option('use-new-tools',
    help='put new tools in the tarball',
    nargs=0,
)

add_option('use-cpu-profiler',
    help='Link against the google-perftools profiler library',
    nargs=0,
)

add_option('build-fast-and-loose',
    choices=['on', 'off'],
    const='on',
    default='on',
    help='looser dependency checking, ignored for --release builds',
    nargs='?',
    type='choice',
)

add_option('disable-warnings-as-errors',
    help="Don't add -Werror to compiler command line",
    nargs=0,
)

add_option('variables-help',
    help='Print the help text for SCons variables',
    nargs=0,
)

add_option('osx-version-min',
    help='minimum OS X version to support',
)

win_version_min_choices = {
    'vista'   : ('0600', '0000'),
    'win7'    : ('0601', '0000'),
    'ws08r2'  : ('0601', '0000'),
    'win8'    : ('0602', '0000'),
    'win81'   : ('0603', '0000'),
}

add_option('win-version-min',
    choices=win_version_min_choices.keys(),
    default=None,
    help='minimum Windows version to support',
    type='choice',
)

add_option('cache',
    help='Use an object cache rather than a per-build variant directory (experimental)',
    nargs=0,
)

add_option('cache-dir',
    default='$BUILD_ROOT/scons/cache',
    help='Specify the directory to use for caching objects if --cache is in use',
)

add_option("experimental-decimal-support",
    choices=['on', 'off'],
    default='off',
    const='on',
    help="Enable experimental decimal128 type support",
    nargs='?',
)

def find_mongo_custom_variables():
    files = []
    for path in sys.path:
        probe = os.path.join(path, 'mongo_custom_variables.py')
        if os.path.isfile(probe):
            files.append(probe)
    return files

add_option('variables-files',
    default=find_mongo_custom_variables(),
    help="Specify variables files to load",
)

link_model_choices = ['auto', 'object', 'static', 'dynamic', 'dynamic-strict']
add_option('link-model',
    choices=link_model_choices,
    default='object',
    help='Select the linking model for the project',
    type='choice'
)

variable_parse_mode_choices=['auto', 'posix', 'other']
add_option('variable-parse-mode',
    choices=variable_parse_mode_choices,
    default=variable_parse_mode_choices[0],
    help='Select which parsing mode is used to interpret command line variables',
    type='choice',
)

add_option('modules',
    help="Comma-separated list of modules to build. Empty means none. Default is all.",
)

try:
    with open("version.json", "r") as version_fp:
        version_data = json.load(version_fp)

    if 'version' not in version_data:
        print "version.json does not contain a version string"
        Exit(1)
    if 'githash' not in version_data:
        version_data['githash'] = utils.getGitVersion()

except IOError as e:
    # If the file error wasn't because the file is missing, error out
    if e.errno != errno.ENOENT:
        print "Error opening version.json: {0}".format(e.strerror)

=== src/third_party/wiredtiger/SConstruct ===
# -*- mode: python; -*-
import re
import os
import shutil
import subprocess
import sys
import tempfile
import textwrap
import distutils.sysconfig

EnsureSConsVersion( 2, 0, 0 )

if not os.sys.platform == "win32":
    print ("SConstruct is only supported for Windows, use build_posix for other platforms")
    Exit(1)

# Command line options
#
AddOption("--dynamic-crt", dest="dynamic-crt", action="store_true", default=False,
          help="Link with the MSVCRT DLL version")

AddOption("--enable-attach", dest="attach", action="store_true", default=False,
          help="Configure for debugger attach on failure.")

AddOption("--enable-diagnostic", dest="diagnostic", action="store_true", default=False,
          help="Configure WiredTiger to perform various run-time diagnostic tests. DO NOT configure this option in production environments.")

AddOption("--enable-lz4", dest="lz4", type="string", nargs=1, action="store",
          help="Use LZ4 compression")

AddOption("--enable-python", dest="lang-python", type="string", nargs=1, action="store",
          help="Build Python extension, specify location of swig.exe binary")

AddOption("--enable-snappy", dest="snappy", type="string", nargs=1, action="store",
          help="Use snappy compression")

AddOption("--enable-tcmalloc", dest="tcmalloc", type="string", nargs=1, action="store",
          help="Use TCMalloc for memory allocation")

AddOption("--enable-verbose", dest="verbose", action="store_true", default=False,
          help="Configure WiredTiger to support the verbose configuration string to wiredtiger_open")

AddOption("--enable-zlib", dest="zlib", type="string", nargs=1, action="store",
          help="Use zlib compression")

AddOption("--prefix", dest="prefix", type="string", nargs=1, action="store", default="package",
          help="Install directory")

AddOption("--with-berkeley-db", dest="bdb", type="string", nargs=1, action="store",
          help="Berkeley DB install path, ie, /usr/local")

# Get the swig binary from the command line option since SCONS cannot find it automatically
#
swig_binary = GetOption("lang-python")

# Initialize environment
#
var = Variables()

var.Add('MSVC_USE_SCRIPT', 'Path to vcvars.bat to override SCons default VS tool search');

var.Add('CPPPATH', 'C Preprocessor include path', [
    "#/src/include/",
    "#/build_win",
    "#/test/windows",
    "#/.",
])

var.Add('CFLAGS', 'C Compiler Flags', [
    "/Z7", # Generate debugging symbols
    "/wd4090", # Ignore warning about mismatched const qualifiers
    "/wd4996", # Ignore deprecated functions
    "/W3", # Warning level 3
    #"/we4244", # Possible loss of data
    "/we4013", # Error on undefined functions
    #"/we4047", # Indirection differences in types
    #"/we4024", # Differences in parameter types
    #"/we4100", # Unreferenced local parameter
    "/TC", # Compile as C code
    #"/Od", # Disable optimization
    "/Ob1", # inline expansion
    "/O2", # optimize for speed
    "/GF", # enable string pooling
    "/EHsc", # extern "C" does not throw
    #"/RTC1", # enable stack checks
    "/GS", # enable security checks
    "/Gy", # separate functions for linker
    "/Zc:wchar_t",
    "/Gd",
    "/MD" if GetOption("dynamic-crt") else "/MT",
])

var.Add('LINKFLAGS', 'Linker Flags', [
    "/DEBUG", # Generate debug symbols
    "/INCREMENTAL:NO", # Disable incremental linking
    "/OPT:REF", # Remove dead code
    "/DYNAMICBASE",
    "/NXCOMPAT",
])

var.Add('TOOLS', 'SCons tools', [
    "default",
    "swig",
    "textfile"
])

var.Add('SWIG', 'SWIG binary location', swig_binary)

env = Environment(
    variables = var
)

env['STATIC_AND_SHARED_OBJECTS_ARE_THE_SAME'] = 1

useZlib = GetOption("zlib")
useSnappy = GetOption("snappy")
useLz4 = GetOption("lz4")
useBdb = GetOption("bdb")
useTcmalloc = GetOption("tcmalloc")
wtlibs = []

conf = Configure(env)
if not conf.CheckCHeader('stdlib.h'):
    print 'stdlib.h must be installed!'
    Exit(1)

if useZlib:
    conf.env.Append(CPPPATH=[useZlib + "/include"])
    conf.env.Append(LIBPATH=[useZlib + "/lib"])
    if conf.CheckCHeader('zlib.h'):
        conf.env.Append(CPPDEFINES=["HAVE_BUILTIN_EXTENSION_ZLIB"])
        wtlibs.append("zlib")
    else:
        print 'zlib.h must be installed!'
        Exit(1)

if useSnappy:
    conf.env.Append(CPPPATH=[useSnappy + "/include"])
    conf.env.Append(LIBPATH=[useSnappy + "/lib"])
    if conf.CheckCHeader('snappy-c.h'):
        conf.env.Append(CPPDEFINES=['HAVE_BUILTIN_EXTENSION_SNAPPY'])
        wtlibs.append("snappy")
    else:
        print 'snappy-c.h must be installed!'
        Exit(1)

if useLz4:
    conf.env.Append(CPPPATH=[useLz4 + "/include"])
    conf.env.Append(LIBPATH=[useLz4 + "/lib"])
    if conf.CheckCHeader('lz4.h'):
        conf.env.Append(CPPDEFINES=['HAVE_BUILTIN_EXTENSION_LZ4'])
        wtlibs.append("lz4")
    else:
        print 'lz4.h must be installed!'
        Exit(1)

if useBdb:
    conf.env.Append(CPPPATH=[useBdb+ "/include"])
    conf.env.Append(LIBPATH=[useBdb+ "/lib"])
    if not conf.CheckCHeader('db.h'):
        print 'db.h must be installed!'
        Exit(1)

if useTcmalloc:
    conf.env.Append(CPPPATH=[useTcmalloc + "/include"])
    conf.env.Append(LIBPATH=[useTcmalloc + "/lib"])
    if conf.CheckCHeader('gperftools/tcmalloc.h'):
        wtlibs.append("libtcmalloc_minimal")
        conf.env.Append(CPPDEFINES=['HAVE_LIBTCMALLOC'])
        conf.env.Append(CPPDEFINES=['HAVE_POSIX_MEMALIGN'])
    else:
        print 'tcmalloc.h must be installed!'
        Exit(1)

env = conf.Finish()

# Configure build environment variables
#
if GetOption("attach"):
    env.Append(CPPDEFINES = ["HAVE_ATTACH"])

if GetOption("diagnostic"):
    env.Append(CPPDEFINES = ["HAVE_DIAGNOSTIC"])

if GetOption("lang-python"):
    env.Append(LIBPATH=[distutils.sysconfig.PREFIX + r"\libs"])
    env.Append(CPPPATH=[distutils.sysconfig.get_python_inc()])

if GetOption("verbose"):
    env.Append(CPPDEFINES = ["HAVE_VERBOSE"])


# Build WiredTiger.h file
#
version_file = 'build_posix/aclocal/version-set.m4'

VERSION_MAJOR = None
VERSION_MINOR = None
VERSION_PATCH = None
VERSION_STRING = None

# Read the version information from the version-set.m4 file
for l in open(File(version_file).srcnode().abspath):
    if re.match(r'^VERSION_[A-Z]+', l):
        exec(l)

if (VERSION_MAJOR == None or
    VERSION_MINOR == None or
    VERSION_PATCH == None or
    VERSION_STRING == None):
    print "Failed to find version variables in " + version_file
    Exit(1)

wiredtiger_includes = """
        #include <sys/types.h>
        #include <stdarg.h>
        #include <stdbool.h>
        #include <stdint.h>
        #include <stdio.h>
    """
wiredtiger_includes = textwrap.dedent(wiredtiger_includes)
replacements = {
    '@VERSION_MAJOR@' : VERSION_MAJOR,
    '@VERSION_MINOR@' : VERSION_MINOR,
    '@VERSION_PATCH@' : VERSION_PATCH,
    '@VERSION_STRING@' : VERSION_STRING,
    '@uintmax_t_decl@': "",
    '@uintptr_t_decl@': "",
    '@off_t_decl@' : 'typedef int64_t wt_off_t;',
    '@wiredtiger_includes_decl@': wiredtiger_includes
}

wtheader = env.Substfile(
    target='wiredtiger.h',
    source=[
        'src/include/wiredtiger.in',
    ],
    SUBST_DICT=replacements)

#
# WiredTiger library
#
# Map WiredTiger build conditions: any conditions that appear in WiredTiger's
# dist/filelist must appear here, and if the value is true, those files will be
# included.
#
condition_map = {
    'POSIX_HOST' : env['PLATFORM'] == 'posix',
    'POWERPC_HOST' : False,
    'WINDOWS_HOST' : env['PLATFORM'] == 'win32',
}

def filtered_filelist(f):
    for line in f:
        file_cond = line.split()
        if line.startswith("#") or len(file_cond) == 0:
            continue
        if len(file_cond) == 1 or condition_map[file_cond[1]]:
            yield file_cond[0]

filelistfile = r'dist/filelist'
wtsources = list(filtered_filelist(open(filelistfile)))

if useZlib:
    wtsources.append("ext/compressors/zlib/zlib_compress.c")

if useSnappy:
    wtsources.append("ext/compressors/snappy/snappy_compress.c")

if useLz4:
    wtsources.append("ext/compressors/lz4/lz4_compress.c")

wt_objs = [env.Object(a) for a in wtsources]

# Static Library - libwiredtiger.lib
#
wtlib = env.Library(
    target="libwiredtiger",
    source=wt_objs, LIBS=wtlibs)

env.Depends(wtlib, [filelistfile, version_file])

# Dynamically Loaded Library - wiredtiger.dll
#
wtdll = env.SharedLibrary(
    target="wiredtiger",
    source=wt_objs + ['build_win/wiredtiger.def'], LIBS=wtlibs)

env.Depends(wtdll, [filelistfile, version_file])

Default(wtlib, wtdll)

wtbin = env.Program("wt", [
    "src/utilities/util_backup.c",
    "src/utilities/util_cpyright.c",
    "src/utilities/util_compact.c",
    "src/utilities/util_create.c",
    "src/utilities/util_drop.c",
    "src/utilities/util_dump.c",
    "src/utilities/util_list.c",
    "src/utilities/util_load.c",
    "src/utilities/util_load_json.c",
    "src/utilities/util_loadtext.c",
    "src/utilities/util_main.c",
    "src/utilities/util_misc.c",
    "src/utilities/util_printlog.c",
    "src/utilities/util_read.c",
    "src/utilities/util_rebalance.c",
    "src/utilities/util_rename.c",
    "src/utilities/util_salvage.c",
    "src/utilities/util_stat.c",
    "src/utilities/util_upgrade.c",
    "src/utilities/util_verbose.c",
    "src/utilities/util_verify.c",
    "src/utilities/util_write.c"],
    LIBS=[wtlib] + wtlibs)

Default(wtbin)

# Python SWIG wrapper for WiredTiger
if GetOption("lang-python"):
    # Check that this version of python is 64-bit
    #
    if sys.maxsize < 2**32:
        print "The Python Interpreter must be 64-bit in order to build the python bindings"
        Exit(1)

    pythonEnv = env.Clone()
    pythonEnv.Append(SWIGFLAGS=[
            "-python",
            "-threads",
            "-O",
            "-nodefaultctor",
            "-nodefaultdtor",
            ])

    swiglib = pythonEnv.SharedLibrary('_wiredtiger',
                      [ 'lang\python\wiredtiger.i'],
                      SHLIBSUFFIX=".pyd",
                      LIBS=[wtlib] + wtlibs)

    copySwig = pythonEnv.Command(
        'lang/python/wiredtiger/__init__.py',
        'lang/python/wiredtiger.py',
        Copy('$TARGET', '$SOURCE'))
    pythonEnv.Depends(copySwig, swiglib)

    swiginstall = pythonEnv.Install('lang/python/wiredtiger/', swiglib)

    Default(swiginstall, copySwig)

# Shim library of functions to emulate POSIX on Windows
shim = env.Library("window_shim",
        ["test/windows/windows_shim.c"])



examples = [
    "ex_access",
    "ex_all",
    "ex_async",
    "ex_call_center",
    "ex_config_parse",
    "ex_cursor",
    "ex_data_source",
    "ex_encrypt",
    "ex_extending",
    "ex_file_system",
    "ex_hello",
    "ex_log",
    "ex_pack",
    "ex_process",
    "ex_schema",
    "ex_scope",
    "ex_stat",
    "ex_thread",
    ]

# WiredTiger Smoke Test support
# Runs each test in a custom temporary directory
def run_smoke_test(x):
    print "Running Smoke Test: " + x

    # Make temp dir
    temp_dir = tempfile.mkdtemp(prefix="wt_home")

    try:
        # Set WT_HOME environment variable for test
        os.environ["WIREDTIGER_HOME"] = temp_dir

        # Run the test
        ret = subprocess.call(x);
        if( ret != 0):
            sys.stderr.write("Bad exit code %d\n" % (ret))
            raise Exception()

    finally:
        # Clean directory
        #
        shutil.rmtree(temp_dir)

def builder_smoke_test(target, source, env):
    run_smoke_test(source[0].abspath)
    return None

env.Append(BUILDERS={'SmokeTest' : Builder(action = builder_smoke_test)})

#Build the tests and setup the "scons test" target

testutil = env.Library('testutil',
            [
                'test/utility/misc.c',
                'test/utility/parse_opts.c'
            ])

#Don't test bloom on Windows, its broken
t = env.Program("t_bloom",
    "test/bloom/test_bloom.c",
    LIBS=[wtlib, testutil] + wtlibs)
#env.Alias("check", env.SmokeTest(t))
Default(t)

=== debian/changelog ===
mongodb (1:3.2.9-1ubuntu1) zesty; urgency=medium

  * Import Gentoo patch to fix FTBFS with boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 08 Nov 2016 09:50:47 +0000

mongodb (1:3.2.9-1build1) zesty; urgency=high

  * No change rebuild against boost1.62.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 01 Nov 2016 16:31:21 +0000

mongodb (1:3.2.9-1) experimental; urgency=medium

  * New upstream release.
  * Fix build with Boost 1.60 by backporting upstream commit 92c3f80f.
  * Fix FTBFS in src/mongo/base/parse_number_test.cpp with GCC 6.1.
  * Fix FTBFS with GCC 6.1 by ignoring overflow checks as upstream's test suite
    explicitly triggers overflows.

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Fri, 02 Sep 2016 12:17:27 +0300

mongodb (1:3.2.8-2) experimental; urgency=medium

  * Disable wiredtiger on 32-bit systems; Wiredtiger only supports 64-bit
    platforms.

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Fri, 15 Jul 2016 15:59:41 +0300

mongodb (1:3.2.8-1) experimental; urgency=medium

  * New upstream release
    + Enable wiredtiger (using the bundled copy for the time being)
  * Upload to experimental
  * Drop irrelevant or merged/fixed upstream patches:
    + ppc64el patch
    + Fix-GCC-5-FTBFS.patch
    + fix-yaml-detection
    + add-option-to-disable-javascript.patch
    + disable-warnings.patch
    + no-unused-function.patch
    + 0006-Fix-ARM-alignment-problems.patch
    + 0099-Pagesize-hacks.patch
    + 0004-kfreebsd-does-not-have-sys-prctl.h.patch
  * Refresh remaining patches
  * scons:
    + 'scons smoke' is gone, run smoke directly
    + Use the new test suite arguments for scons
  * mongodb-clients: drop binaries removed upstream
    + Also drop manpages of missing binaries
  * Remove v8 B-D, mongodb now uses a bundled greasemonkey copy
  * B-D on zlib1g-dev and libboost-regex-dev
  * Use system valgrind
  * d/copyright:
    + update for 3.2
    + fix zlib file matching
  * d/watch: search for stable 3.2 releases
  * lintian:
    + relax source override for utils.js to allow long lines of any
      length (and not just 565 characters)
    + remove unused overrides for PCRE

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Thu, 14 Jul 2016 16:42:32 +0300

=== debian/control ===
Source: mongodb
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Uploaders: Jérémy Lal <kapouer@melix.org>,
           Apollon Oikonomopoulos <apoikos@debian.org>
Build-Depends:
 debhelper (>= 9),
 dh-systemd (>= 1.5),
 libboost-date-time-dev,
 libboost-dev (>> 1.50),
 libboost-filesystem-dev,
 libboost-program-options-dev,
 libboost-thread-dev,
 libboost-regex-dev,
 libgoogle-perftools-dev [linux-amd64 linux-i386 armhf],
 libyaml-cpp-dev,
 libpcap-dev,
 libpcre3-dev,
 libreadline-dev,
 libsnappy-dev,
 libstemmer-dev,
 libssl-dev,
 zlib1g-dev,
 python-pymongo,
 python,
 scons,
 valgrind
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/collab-maint/mongodb.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mongodb.git/
Homepage: https://www.mongodb.org

Package: mongodb
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf arm64 ppc64el
Depends: mongodb-server (>= 1:2.4.1-2), ${misc:Depends}, ${shlibs:Depends}
Description: object/document-oriented database (metapackage)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This is a convenience metapackage that depends on all the mongodb parts:
 the server, the clients and the development files (headers and library).

Package: mongodb-server
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf arm64 ppc64el
Depends:
 mongodb-clients,
 adduser,
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (server package)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the server itself  (mongod) and the sharding
 server/load-balancer (mongos).

Package: mongodb-clients
Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf arm64 ppc64el
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Replaces:
 mongodb (<= 1:1.4.2-2)
Description: object/document-oriented database (client apps)
 MongoDB is a high-performance, open source, schema-free
 document-oriented data store that's easy to deploy, manage
 and use. It's network accessible, written in C++ and offers
 the following features:
 .
    * Collection oriented storage - easy storage of object-style data
    * Full index support, including on inner objects
    * Query profiling
    * Replication and fail-over support
    * Efficient storage of binary data including large objects (e.g. videos)
    * Auto-sharding for cloud-level scalability
 .
 High performance, scalability, and reasonable depth of
 functionality are the goals for the project.
 .
 This package contains the standard administrative shell (mongo) and other
 utilities for administration or analysis of performance of the server.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Use gcc and g++ by default, but allow setting them from the environment
CC ?= gcc
CXX ?= g++

DEB_SCONS_OPTIONS :=
ifneq (,$(filter debug,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_OPTIONS := --d=DEBUGBUILD
endif

ifeq (,$(filter nodbgsym,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += --nostrip
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       PROCS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
       DEB_SCONS_OPTIONS += -j$(PROCS)
endif

COMMON_OPTIONS = --use-system-tcmalloc --use-system-pcre \
		 --use-system-boost --use-system-snappy \
		 --use-system-zlib --use-system-valgrind \
		 --use-system-stemmer --use-system-yaml \
		 --ssl $(DEB_SCONS_OPTIONS) \
		 CC=$(CC) CXX=$(CXX)

gperftools_archs = amd64 i386 armhf
ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
COMMON_OPTIONS += --allocator=tcmalloc
else
COMMON_OPTIONS += --allocator=system
endif

# Wiredtiger does not build on 32-bit systems
ifeq (32, $(DEB_HOST_ARCH_BITS))
COMMON_OPTIONS += --wiredtiger=off
endif

override_dh_auto_clean:
	scons --keep-going --clean $(COMMON_OPTIONS) .
	find $(CURDIR)/ -name "*.pyc" -delete
	rm -rf $(CURDIR)/debian/tmp-test/
	rm -rf $(CURDIR)/.scons/
	rm -rf $(CURDIR)/build/
	rm -f $(CURDIR)/failfile.smoke $(CURDIR)/smoke-last.json

override_dh_auto_build:
	scons $(COMMON_OPTIONS) core tools

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	scons $(COMMON_OPTIONS) dbtest unittests integration_tests
	python ./buildscripts/smoke.py --smoke-db-prefix="$(CURDIR)/debian/tmp-test"
.PHONY: override_dh_auto_test
endif

override_dh_auto_install:
	scons $(COMMON_OPTIONS) --prefix=$(CURDIR)/debian/tmp/usr install

override_dh_systemd_enable:
	dh_systemd_enable -pmongodb-server --name=mongodb

override_dh_installinit:
	dh_installinit -pmongodb-server --name=mongodb


override_dh_install:
	dh_install --list-missing

%:
	dh $@ --parallel --with=systemd

.PHONY: override_dh_auto_clean override_dh_auto_build \
	override_dh_auto_install override_dh_installinit \
	override_dh_systemd_enable override_dh_install

=== debian/watch ===
version=3
opts=uversionmangle=s/(\d)-(rc\d+)$/$1~$2/ \
http://www.mongodb.org/dl/src/ .*/mongodb-src-r(3\.2\..*)\.tar\.gz

## mongodb 3.2.11

=== SConstruct ===
--- 
+++ 
@@ -13,6 +13,8 @@
 import uuid
 from buildscripts import utils
 from buildscripts import moduleconfig
+
+import SCons
 
 from mongo_scons_utils import (
     default_buildinfo_environment_data,
@@ -422,8 +424,10 @@
 )
 
 add_option('cache',
+    choices=["all", "nolinked"],
+    const='all',
     help='Use an object cache rather than a per-build variant directory (experimental)',
-    nargs=0,
+    nargs='?',
 )
 
 add_option('cache-dir',
@@ -485,4 +489,3 @@
 except IOError as e:
     # If the file error wasn't because the file is missing, error out
     if e.errno != errno.ENOENT:
-        print "Error opening version.json: {0}".format(e.strerror)

=== debian/changelog ===
mongodb (1:3.2.11-2+deb9u1.lnd.3) stretch; urgency=medium

  * Non-maintainer upload.
  * rebuild for mstrict-align

 -- root <root@loongson-pc>  Fri, 28 Jan 2022 16:06:06 +0800

mongodb (1:3.2.11-2+deb9u1.lnd.2) experimental; urgency=medium

  * fix reg name on linux_syscall_support.h

 -- wujiahuan <wujiahuan@loongson.cn>  Wed, 14 Apr 2021 10:25:44 +0800

mongodb (1:3.2.11-2+deb9u1.lnd1) experimental; urgency=medium

  * change asio version of mongodb on loongarch64
  * add loongarch64 platform support

 -- wujiahuan <wujiahaun@loongson.cn>  Fri, 09 Apr 2021 09:42:22 +0800

mongodb (1:3.2.11-2+deb9u1) stretch; urgency=medium

  * Fix segfault/FTBFS on ARM64 with 48-bit virtual addresses (Closes: #871906)
  * Fix spidermonkey GC segfault when built with GCC 6 (Closes: #876755)
  * mongodb.service: start after network.target (Closes: #864407)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Mon, 02 Oct 2017 11:14:03 +0300

mongodb (1:3.2.11-2) unstable; urgency=medium

  * Drop armhf builds; currently FTBFS and is unsupported upstream
    (Closes: #836435)
  * Set MMAPv1 as the default storage engine on i386; fixes FTBFS on i386
  * Fix ARM64 detection in WT; fixes FTBFS on arm64

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Thu, 15 Dec 2016 20:04:56 +0200

mongodb (1:3.2.11-1) unstable; urgency=medium

  * New upstream stable release
  * Upload to unstable
  * mongodb-clients: recommend mongodb-tools
  * Disable kFreeBSD and HURD builds, until we finish porting the patches from
    earlier versions
  * d/watch: verify upstream tarball signatures
  * Fix build with boost 1.62; patch by NetBSD
  * B-D on libssl1.0-dev (Closes: #828438)
  * B-D on tzdata (Closes: #839505)
  * Refactor DEP-8 tests
  * Set maintainer to pkg-mongodb, move Lászlo to Uploaders and update Vcs-*
    URLs
  * mongodb-server: Depend on lsb-base for the initscript
  * Use resmoke to run db and unit tests
    + B-D on python-yaml and python-subprocess32
  * d/copyright: drop files removed upstream
  * mongodb-server: remove unused lintian override

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Thu, 15 Dec 2016 11:06:03 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: mongodb
 Section: database
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Uploaders: Jérémy Lal <kapouer@melix.org>,
+Maintainer: Debian MongoDB Maintainers <pkg-mongodb-maintainers@lists.alioth.debian.org>
+Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>,
+           Jérémy Lal <kapouer@melix.org>,
            Apollon Oikonomopoulos <apoikos@debian.org>
 Build-Depends:
  debhelper (>= 9),
@@ -14,7 +14,7 @@
  libboost-program-options-dev,
  libboost-thread-dev,
  libboost-regex-dev,
- libgoogle-perftools-dev [linux-amd64 linux-i386 armhf],
+ libgoogle-perftools-dev [linux-amd64 linux-i386],
  libyaml-cpp-dev,
  libpcap-dev,
  libpcre3-dev,
@@ -24,16 +24,18 @@
  libssl-dev,
  zlib1g-dev,
  python-pymongo,
+ python-subprocess32,
+ python-yaml,
  python,
  scons,
- valgrind
+ tzdata
 Standards-Version: 3.9.8
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/mongodb.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/mongodb.git/
+Vcs-Git: https://anonscm.debian.org/git/pkg-mongodb/mongodb.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-mongodb/mongodb.git/
 Homepage: https://www.mongodb.org
 
 Package: mongodb
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf arm64 ppc64el
+Architecture: amd64 i386 arm64 ppc64el loongarch64
 Depends: mongodb-server (>= 1:2.4.1-2), ${misc:Depends}, ${shlibs:Depends}
 Description: object/document-oriented database (metapackage)
  MongoDB is a high-performance, open source, schema-free
@@ -55,10 +57,11 @@
  the server, the clients and the development files (headers and library).
 
 Package: mongodb-server
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf arm64 ppc64el
+Architecture: amd64 i386 arm64 ppc64el loongarch64
 Depends:
  mongodb-clients,
- adduser,
+ adduser, 
+ lsb-base (>= 3.0-6),
  ${misc:Depends},
  ${shlibs:Depends}
 Replaces:
@@ -83,10 +86,11 @@
  server/load-balancer (mongos).
 
 Package: mongodb-clients
-Architecture: amd64 i386 kfreebsd-amd64 kfreebsd-i386 hurd-any armhf arm64 ppc64el
+Architecture: amd64 i386 arm64 ppc64el loongarch64
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}
+Recommends: mongo-tools
 Replaces:
  mongodb (<= 1:1.4.2-2)
 Description: object/document-oriented database (client apps)

=== debian/rules ===
--- 
+++ 
@@ -22,14 +22,14 @@
        DEB_SCONS_OPTIONS += -j$(PROCS)
 endif
 
-COMMON_OPTIONS = --use-system-tcmalloc --use-system-pcre \
+COMMON_OPTIONS = --use-system-pcre \
 		 --use-system-boost --use-system-snappy \
-		 --use-system-zlib --use-system-valgrind \
+		 --use-system-zlib --disable-warnings-as-errors \
 		 --use-system-stemmer --use-system-yaml \
 		 --ssl $(DEB_SCONS_OPTIONS) \
 		 CC=$(CC) CXX=$(CXX)
 
-gperftools_archs = amd64 i386 armhf
+gperftools_archs = amd64 i386 armhf loongarch64
 ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
 COMMON_OPTIONS += --allocator=tcmalloc
 else
@@ -47,15 +47,14 @@
 	rm -rf $(CURDIR)/debian/tmp-test/
 	rm -rf $(CURDIR)/.scons/
 	rm -rf $(CURDIR)/build/
-	rm -f $(CURDIR)/failfile.smoke $(CURDIR)/smoke-last.json
 
 override_dh_auto_build:
 	scons $(COMMON_OPTIONS) core tools
 
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 override_dh_auto_test:
-	scons $(COMMON_OPTIONS) dbtest unittests integration_tests
-	python ./buildscripts/smoke.py --smoke-db-prefix="$(CURDIR)/debian/tmp-test"
+	scons $(COMMON_OPTIONS) dbtest unittests
+	python ./buildscripts/resmoke.py --dbpathPrefix="$(CURDIR)/debian/tmp-test" --suites=dbtest,unittests
 .PHONY: override_dh_auto_test
 endif

## mongodb 3.4.1

=== SConstruct ===
--- 
+++ 
@@ -1,4 +1,5 @@
 # -*- mode: python; -*-
+import atexit
 import copy
 import datetime
 import errno
@@ -25,6 +26,12 @@
 import libdeps
 
 EnsureSConsVersion( 2, 3, 0 )
+
+def print_build_failures():
+    from SCons.Script import GetBuildFailures
+    for bf in GetBuildFailures():
+        print "%s failed: %s" % (bf.node, bf.errstr)
+atexit.register(print_build_failures)
 
 def versiontuple(v):
     return tuple(map(int, (v.split("."))))
@@ -319,14 +326,6 @@
     nargs=0,
 )
 
-boost_choices = ['1.56']
-add_option('internal-boost',
-    choices=boost_choices,
-    default=boost_choices[0],
-    help='Specify internal boost version to use',
-    type='choice',
-)
-
 add_option('system-boost-lib-search-suffixes',
     help='Comma delimited sequence of boost library suffixes to search',
 )
@@ -365,6 +364,11 @@
     nargs=0,
 )
 
+add_option('use-system-icu',
+    help="use system version of ICU",
+    nargs=0,
+)
+
 add_option('use-system-intel_decimal128',
     help='use system version of intel decimal128',
     nargs=0,
@@ -380,16 +384,21 @@
     nargs=0,
 )
 
+add_option('build-mongoreplay',
+    help='when building with --use-new-tools, build mongoreplay ( requires pcap dev )',
+    nargs=1,
+)
+
 add_option('use-cpu-profiler',
     help='Link against the google-perftools profiler library',
     nargs=0,
 )
 
 add_option('build-fast-and-loose',
-    choices=['on', 'off'],
-    const='on',
-    default='on',
-    help='looser dependency checking, ignored for --release builds',
+    choices=['on', 'off', 'auto'],
+    const='on',
+    default='auto',
+    help='looser dependency checking',
     nargs='?',
     type='choice',
 )
@@ -435,12 +444,10 @@
     help='Specify the directory to use for caching objects if --cache is in use',
 )
 
-add_option("experimental-decimal-support",
-    choices=['on', 'off'],
-    default='off',
-    const='on',
-    help="Enable experimental decimal128 type support",
-    nargs='?',
+add_option("cxx-std",
+    choices=["11", "14"],
+    default="11",
+    help="Select the C++ langauge standard to build with",
 )
 
 def find_mongo_custom_variables():
@@ -476,16 +483,13 @@
     help="Comma-separated list of modules to build. Empty means none. Default is all.",
 )
 
-try:
-    with open("version.json", "r") as version_fp:
-        version_data = json.load(version_fp)
-
-    if 'version' not in version_data:
-        print "version.json does not contain a version string"
-        Exit(1)
-    if 'githash' not in version_data:
-        version_data['githash'] = utils.getGitVersion()
-
-except IOError as e:
-    # If the file error wasn't because the file is missing, error out
-    if e.errno != errno.ENOENT:
+add_option('runtime-hardening',
+    choices=["on", "off"],
+    default="on",
+    help="Enable runtime hardening features (e.g. stack smash protection)",
+    type='choice',
+)
+
+add_option('use-s390x-crc32',
+    choices=["on", "off"],
+    default="on",

=== debian/changelog ===
mongodb (1:3.4.1-2ubuntu1) zesty; urgency=medium

  [ Apollon Oikonomopoulos ]
  * d/copyright: adjust src/third_party/* paths

  [ Jeremy Bicha ]
  * Try hardware-assisted CRC32 on s390x

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 25 Dec 2016 10:55:40 -0500

mongodb (1:3.4.1-2) experimental; urgency=medium

  * Disable hardware-assisted CRC32 on arm64 and s390x. This fixes FTBFS on
    these architectures.

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Fri, 23 Dec 2016 20:59:49 +0200

mongodb (1:3.4.1-1) experimental; urgency=medium

  * New upstream stable series
    + d/watch: look for 3.4 stable releases
    + Update upstream's signing key for 3.4
    + Drop fix-boost-1.60-build.patch; applied upstream
    + Refresh remaining patches
    + B-D on libboost-iostreams-dev
  * Upload to experimental
  * New patches:
    + Use std::regex instead of boost::regex in mongo shell (fixes FTBFS with
      Debian's boost and C++11)
  * Also build for s390x (Closes: #848298)
  * Drop i386 builds; i386 has long been deprecated upstream and support has
    been essentially removed in 3.4.
  * Use tcmalloc on ppc64el and arm64 as well
  * Do not ship mongosniff, as it is no longer built by the mongodb source
  * d/changelog: restore the 2.6.12-3 entry (Closes: #848305)

 -- Apollon Oikonomopoulos <apoikos@debian.org>  Fri, 23 Dec 2016 14:57:21 +0200

mongodb (1:2.6.12-3) unstable; urgency=high

  * Fix CVE-2016-6494 , prevent group and other access to .dbshell
    (closes: #832908).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 08 Aug 2016 21:56:32 +0000

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: mongodb
 Section: database
 Priority: optional
-Maintainer: Debian MongoDB Maintainers <pkg-mongodb-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian MongoDB Maintainers <pkg-mongodb-maintainers@lists.alioth.debian.org>
 Uploaders: Laszlo Boszormenyi (GCS) <gcs@debian.org>,
            Jérémy Lal <kapouer@melix.org>,
            Apollon Oikonomopoulos <apoikos@debian.org>
@@ -11,31 +12,33 @@
  libboost-date-time-dev,
  libboost-dev (>> 1.50),
  libboost-filesystem-dev,
+ libboost-iostreams-dev,
  libboost-program-options-dev,
  libboost-thread-dev,
  libboost-regex-dev,
- libgoogle-perftools-dev [linux-amd64 linux-i386],
+ libgoogle-perftools-dev [linux-amd64 linux-arm64 linux-ppc64el],
  libyaml-cpp-dev,
  libpcap-dev,
  libpcre3-dev,
  libreadline-dev,
  libsnappy-dev,
  libstemmer-dev,
- libssl-dev,
+ libssl1.0-dev,
  zlib1g-dev,
  python-pymongo,
  python-subprocess32,
  python-yaml,
  python,
  scons,
- tzdata
+ tzdata,
+ valgrind
 Standards-Version: 3.9.8
 Vcs-Git: https://anonscm.debian.org/git/pkg-mongodb/mongodb.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-mongodb/mongodb.git/
 Homepage: https://www.mongodb.org
 
 Package: mongodb
-Architecture: amd64 i386 arm64 ppc64el loongarch64
+Architecture: amd64 arm64 ppc64el s390x
 Depends: mongodb-server (>= 1:2.4.1-2), ${misc:Depends}, ${shlibs:Depends}
 Description: object/document-oriented database (metapackage)
  MongoDB is a high-performance, open source, schema-free
@@ -57,7 +60,7 @@
  the server, the clients and the development files (headers and library).
 
 Package: mongodb-server
-Architecture: amd64 i386 arm64 ppc64el loongarch64
+Architecture: amd64 arm64 ppc64el s390x
 Depends:
  mongodb-clients,
  adduser, 
@@ -86,7 +89,7 @@
  server/load-balancer (mongos).
 
 Package: mongodb-clients
-Architecture: amd64 i386 arm64 ppc64el loongarch64
+Architecture: amd64 arm64 ppc64el s390x
 Depends:
  ${misc:Depends},
  ${shlibs:Depends}

=== debian/rules ===
--- 
+++ 
@@ -22,14 +22,20 @@
        DEB_SCONS_OPTIONS += -j$(PROCS)
 endif
 
-COMMON_OPTIONS = --use-system-pcre \
+# Disable hardware-assisted crc32 on Debian since the buildd's don't
+# support it, but try enabling it on Ubuntu
+ifneq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
+    DEB_S390X_OPTIONS += --use-s390x-crc32=off
+endif
+
+COMMON_OPTIONS = --use-system-tcmalloc --use-system-pcre \
 		 --use-system-boost --use-system-snappy \
-		 --use-system-zlib --disable-warnings-as-errors \
+		 --use-system-zlib --use-system-valgrind \
 		 --use-system-stemmer --use-system-yaml \
-		 --ssl $(DEB_SCONS_OPTIONS) \
+		 --ssl $(DEB_SCONS_OPTIONS) $(DEB_S390X_OPTIONS) \
 		 CC=$(CC) CXX=$(CXX)
 
-gperftools_archs = amd64 i386 armhf loongarch64
+gperftools_archs = amd64 ppc64el arm64
 ifneq (,$(filter $(DEB_HOST_ARCH), $(gperftools_archs)))
 COMMON_OPTIONS += --allocator=tcmalloc
 else

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.sig/,uversionmangle=s/(\d)-(rc\d+)$/$1~$2/ \
	http://www.mongodb.org/dl/src/ .*/mongodb-src-r(3\.4\..*)\.tar\.gz
